{A simple program to test the unit plard14. It evaluates the geometric
coordinates of planets and moon and earth's velocity components at selected
TDB Julian dates}

{$N+}
PROGRAM cposd;

USES crt,dos,plard14;

CONST
WPG : extended = 5.729577951308232087e+1;  {180/pi}

VAR
g,m,a,h,gi,mi,ai,hi,pi,p,i,k,a1,a2 : integer;
al,cl,j : longint;
je,f,fj : extended;
ch : char;
strn : string;
fl : boolean;
wx,wy,wx2,b : byte;
lon,lat,r,a3 : double;
s : array[1..7] of string;
fil : searchrec;

FUNCTION exist(f: string): boolean;
BEGIN
findfirst(f,anyfile-volumeid-directory,fil);
exist:=doserror=0
END;

FUNCTION getkey:char;
BEGIN
ch:=readkey;
if ch=#0 then ch:=chr(ord(readkey)+128);
getkey:=ch;
END;

PROCEDURE Inputint(maxcar:byte); {input integer >=0}
BEGIN
b:=0;
strn:='';
repeat
ch:=getkey;
IF (ch=#8) and (b>0) then begin
write(#8' '#8);
delete(strn,b,1);
dec(b);
end
else
if (ch>#47) and (ch<#58) and (b<maxcar) then begin
inc(b);
strn:=strn+ch;
write(ch);
end;
until ch=#13;
val(strn,i,k) 
END;

PROCEDURE inpdate;   {input date}
label 50,51,52,53,54;
BEGIN
write('day: ');
wx:=wherex; wy:=wherey;
50:
gotoxy(wx,wy);
clreol;
inputint(2);
If strn='' then exit;
if (i<1) or (i>31) then goto 50;
if i<10 then write(' ');
write('  month: ');
gi:=i;
51:
gotoxy(wx+11,wy);
clreol;
gotoxy(wx+11,wy);
inputint(2);
If strn='' then goto 50;
if (i<1) or (i>12) then goto 51;
if ((i<>2) and (gi>30+((i+(i div 8)) and 1)))
or ((i=2) and (gi>29)) then goto 50;
if i<10 then write(' ');
write('  year: ');
mi:=i;
52:
gotoxy(wx+21,wy);
clreol;
inputint(4);
if i>3000 then goto 52;
if strn='' then goto 51;
if (gi*mi)=58 then begin
pi:=i;
if (pi mod 100=0) then pi:=pi div 100;
if (pi mod 4>0) then goto 50;
end;
gotoxy(wx+21,wy);
write(i);
ai:=i;
write('   hours: ');
wx2:=wherex;
53:
gotoxy(wx2,wy);
clreol;
inputint(2);
If strn='' then goto 52;
if i>24 then goto 53;
if i=24 then i:=0;
gotoxy(wx2,wy);
write(i);
if i<10 then write(' ');
write('  minutes: ');
hi:=i;
54:
gotoxy(wx2+13,wy);
write('  ');
gotoxy(wx2+13,wy);
inputint(2);
if strn='' then goto 53;
if i>59 then goto 54;
gotoxy(wx2+13,wy);
write(i);
p:=i;
g:=gi; m:=mi; a:=ai; h:=hi;
writeln
END;

PROCEDURE jd3;  {calculates Julian day number from date}
BEGIN
cl:=m+1; al:=a;
if m<3 then begin
dec(al); inc(cl,12);
end;
j:=((1461*(al+4716)) div 4)+((153*cl) div 5)+g-1524;
if j>2299170 then begin
al:=al div 100;
al:=al-(al div 4)-2;
dec(j,al);
end;
if f<0.5 then begin
fj:=f+0.5; dec(j)
end
else fj:=f-0.5
END;

PROCEDURE fcoord(np: string);  {displays coordinates}
BEGIN
a3:=lon*WPG;
a1:=trunc(a3);
a3:=frac(a3)*60;
a2:=trunc(a3);
a3:=frac(a3)*60;
str(a1:3,s[1]);
str(a2,s[2]);
if a2<10 then s[2]:='0'+s[2];
str(a3:5:2,s[3]);
if s[3][1]=' ' then delete(s[3],1,1);
if length(s[3])=4 then s[3]:='0'+s[3];
a3:=abs(lat*WPG);
a1:=trunc(a3);
a3:=frac(a3)*60;
a2:=trunc(a3);
a3:=frac(a3)*60;
str(a1,s[4]);
if a1<10 then s[4]:=' '+s[4];
if lat<0 then s[4]:='-'+s[4] else s[4]:='+'+s[4];
str(a2,s[5]);
if a2<10 then s[5]:='0'+s[5];
str(a3:5:2,s[6]);
if s[6][1]=' ' then delete(s[6],1,1);
if length(s[6])=4 then s[6]:='0'+s[6];
str(r:11:8,s[7]);
strn:=np;
while length(strn)<7 do strn:=strn+' ';
write(strn,':  lon ',s[1],' ',s[2],'''',s[3],' deg');
if np='Earth V' then write('/d  ') else write('    ');
write('lat ',s[4],' ',s[5],'''',s[6],' deg');
if np='Earth V' then write('/d  ') else write('    ');
write('R ',s[7],' au');
if np='Earth V' then writeln('/d') else writeln;
END;

BEGIN
clrscr;
if not exist('tabplar.ttb') then begin
writeln('data file unavailable');
halt
end;
pla_getdatamem;
repeat
inpdate;
if strn='' then begin
writeln;
halt;
end;
f:=(h*60+p)/1440;
jd3;
je:=j+fj;
pos_mer(je,lon,lat,r);
fcoord('Mercury');
pos_ven(je,lon,lat,r);
fcoord('Venus');
pos_ear(je,lon,lat,r);
fcoord('Earth');
vel_ear(je,lon,lat,r);
fcoord('Earth V');
pos_moo(je,lon,lat,r);
fcoord('G-Moon');
pos_mar(je,lon,lat,r);
fcoord('Mars');
pos_jup(je,lon,lat,r);
fcoord('Jupiter');
pos_sat(je,lon,lat,r);
fcoord('Saturn');
pos_ura(je,lon,lat,r);
fcoord('Uranus');
pos_nep(je,lon,lat,r);
fcoord('Neptune');
pos_plu(je,lon,lat,r);
fcoord('Pluto');
ch:=readkey;
until ch=#32;
pla_disposemem;
END.
